
/*
 * Copyright (c) 1997 Carter Bullard
 * All applicable rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation is restricted to personal use only.  Use, sale
 * or retransmission of this software for commercial purposes, 
 * including but not limited to use as a commerical product or
 * in support of a commercial endeavor requires licensing from Carter
 * Bullard.
 *
 * CARTER BULLARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL CARTER BULLARD BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
/*
 * Copyright (c) 1988-1990 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @(#) $Header: /us/wcb/packages/argus/argus-1.6/include/RCS/etherproto.h,v 1.1 1995/02/08 21:06:41 poepping Exp wcb $ (LBL)
 */

/* Map between Ethernet protocol types and names */

/* Add other Ethernet packet types here */
#ifndef	ETHERTYPE_SPRITE
#define	ETHERTYPE_SPRITE	0x0500
#endif
#ifndef	ETHERTYPE_MOPDL
#define	ETHERTYPE_MOPDL		0x6001
#endif
#ifndef	ETHERTYPE_MOPRC
#define	ETHERTYPE_MOPRC		0x6002
#endif
#ifndef	ETHERTYPE_MOP
#define	ETHERTYPE_MOP		0x6001
#endif
#ifndef	ETHERTYPE_LAVC
#define	ETHERTYPE_LAVC		0x6007
#endif
#ifndef	ETHERTYPE_DN
#define	ETHERTYPE_DN		0x6003
#endif
#ifndef	ETHERTYPE_LAT
#define	ETHERTYPE_LAT		0x6004
#endif
#ifndef	ETHERTYPE_LANBRIDGE
#define	ETHERTYPE_LANBRIDGE	0x8038
#endif
#ifndef	ETHERTYPE_VEXP
#define	ETHERTYPE_VEXP		0x805b
#endif
#ifndef	ETHERTYPE_VPROD
#define	ETHERTYPE_VPROD		0x805c
#endif
#ifndef	ETHERTYPE_LOOPBACK
#define	ETHERTYPE_LOOPBACK	0x9000
#endif

#ifndef ETHERTYPE_ATALK
#define ETHERTYPE_ATALK		0x809b /* XXX */
#endif
#ifndef ETHERTYPE_AARP
#define ETHERTYPE_AARP		0x80f3
#endif
#ifndef ETHERTYPE_NS
#define ETHERTYPE_NS		0x0600
#endif

struct eproto {
	char *s;
	u_short p;
};

extern struct eproto eproto_db[];
#ifndef ETHERTYPE_PUP
#define ETHERTYPE_PUP           0x0200
#endif
#ifndef ETHERTYPE_PUPAT
#define ETHERTYPE_PUPAT         0x0201
#endif
#ifndef ETHERTYPE_XNSIDP
#define ETHERTYPE_XNSIDP        0x0600
#endif
#ifndef ETHERTYPE_X_75
#define ETHERTYPE_X_75          0x0801
#endif
#ifndef ETHERTYPE_NBS
#define ETHERTYPE_NBS           0x0802
#endif
#ifndef ETHERTYPE_ECMA
#define ETHERTYPE_ECMA          0x0803
#endif
#ifndef ETHERTYPE_CHAOSNET
#define ETHERTYPE_CHAOSNET      0x0804
#endif
#ifndef ETHERTYPE_X_25
#define ETHERTYPE_X_25          0x0805
#endif
#ifndef ETHERTYPE_SYMBOLICS
#define ETHERTYPE_SYMBOLICS     0x081C
#endif
#ifndef ETHERTYPE_IEEE802_3PUP
#define ETHERTYPE_IEEE802_3PUP  0x0A00
#endif
#ifndef ETHERTYPE_IEEE802_3PUPAT
#define ETHERTYPE_IEEE802_3PUPAT 0x0A01
#endif
#ifndef ETHERTYPE_BANYAN
#define ETHERTYPE_BANYAN        0x0BAD
#endif
#ifndef ETHERTYPE_VALID
#define ETHERTYPE_VALID         0x1600
#endif
#ifndef ETHERTYPE_PCS
#define ETHERTYPE_PCS           0x4242
#endif
#ifndef ETHERTYPE_SIMNET
#define ETHERTYPE_SIMNET        0x5208
#endif
#ifndef ETHERTYPE_3COM
#define ETHERTYPE_3COM          0x6010
#endif
#ifndef ETHERTYPE_3COM
#define ETHERTYPE_3COM          0x6011
#endif
#ifndef ETHERTYPE_3COM
#define ETHERTYPE_3COM          0x6012
#endif
#ifndef ETHERTYPE_3COM
#define ETHERTYPE_3COM          0x6013
#endif
#ifndef ETHERTYPE_3COM
#define ETHERTYPE_3COM          0x6014
#endif
#ifndef ETHERTYPE_UBDOWNLOAD
#define ETHERTYPE_UBDOWNLOAD    0x7000
#endif
#ifndef ETHERTYPE_UBDIAGNOSTIC
#define ETHERTYPE_UBDIAGNOSTIC  0x7002
#endif
#ifndef ETHERTYPE_UBUNKNOWN
#define ETHERTYPE_UBUNKNOWN     0x7005
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7020
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7021
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7022
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7023
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7024
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7025
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7026
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7027
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7028
#endif
#ifndef ETHERTYPE_LRT
#define ETHERTYPE_LRT           0x7029
#endif
#ifndef ETHERTYPE_PROTEON
#define ETHERTYPE_PROTEON       0x7030
#endif
#ifndef ETHERTYPE_CABLETRON
#define ETHERTYPE_CABLETRON     0x7034
#endif
#ifndef ETHERTYPE_CRONUSVLN
#define ETHERTYPE_CRONUSVLN     0x8003
#endif
#ifndef ETHERTYPE_CRONUSDIRECT
#define ETHERTYPE_CRONUSdIRECT  0x8004
#endif
#ifndef ETHERTYPE_HPPROBE
#define ETHERTYPE_HPPROBE       0x8005
#endif
#ifndef ETHERTYPE_NESTAR
#define ETHERTYPE_NESTAR        0x8006
#endif
#ifndef ETHERTYPE_ATT
#define ETHERTYPE_ATT           0x8008
#endif
#ifndef ETHERTYPE_EXCELAN
#define ETHERTYPE_EXCELAN       0x8010
#endif
#ifndef ETHERTYPE_SGIDIAGNOSTIC
#define ETHERTYPE_SGIDIAGNOSTIC 0x8013
#endif
#ifndef ETHERTYPE_SGIGAMES
#define ETHERTYPE_SGIGAMES      0x8014
#endif
#ifndef ETHERTYPE_SGIRESERVED
#define ETHERTYPE_SGIRESERVED   0x8015
#endif
#ifndef ETHERTYPE_SGIXNS
#define ETHERTYPE_SGIXNS        0x8016
#endif
#ifndef ETHERTYPE_APOLLO
#define ETHERTYPE_APOLLO        0x8019
#endif
#ifndef ETHERTYPE_TYMSHARE
#define ETHERTYPE_TYMSHARE      0x802E
#endif
#ifndef ETHERTYPE_TIGAN
#define ETHERTYPE_TIGAN         0x802F
#endif
#ifndef ETHERTYPE_AEONIC
#define ETHERTYPE_AEONIC        0x8036
#endif
#ifndef ETHERTYPE_PLANNING
#define ETHERTYPE_PLANNING      0x8044
#endif
#ifndef ETHERTYPE_ATT
#define ETHERTYPE_ATT           0x8046
#endif
#ifndef ETHERTYPE_ATT
#define ETHERTYPE_ATT           0x8047
#endif
#ifndef ETHERTYPE_EXPERDATA
#define ETHERTYPE_EXPERDATA     0x8049
#endif
#ifndef ETHERTYPE_VEXPERIMENTAL
#define ETHERTYPE_VEXPERIMENTAL 0x805B
#endif
#ifndef ETHERTYPE_VPRODUCTION
#define ETHERTYPE_VPRODUCTION   0x805C
#endif
#ifndef ETHERTYPE_ES
#define ETHERTYPE_ES            0x805D
#endif
#ifndef ETHERTYPE_LITTLE
#define ETHERTYPE_LITTLE        0x8060
#endif
#ifndef ETHERTYPE_COUNTERPOINT
#define ETHERTYPE_COUNTERPOINT  0x8062
#endif
#ifndef ETHERTYPE_UOFM
#define ETHERTYPE_UOFM          0x8065
#endif
#ifndef ETHERTYPE_UOFM
#define ETHERTYPE_UOFM          0x8066
#endif
#ifndef ETHERTYPE_VEECO
#define ETHERTYPE_VEECO         0x8067
#endif
#ifndef ETHERTYPE_GD
#define ETHERTYPE_GD            0x8068
#endif
#ifndef ETHERTYPE_ATT
#define ETHERTYPE_ATT           0x8069
#endif
#ifndef ETHERTYPE_AUTOPHON
#define ETHERTYPE_AUTOPHON      0x806A
#endif
#ifndef ETHERTYPE_COMDESIGN
#define ETHERTYPE_COMDESIGN     0x806C
#endif
#ifndef ETHERTYPE_COMPUGRAPHIC
#define ETHERTYPE_COMPUGRAPHIC  0x806D
#endif
#ifndef ETHERTYPE_MANTRA
#define ETHERTYPE_MANTRA        0x807A
#endif
#ifndef ETHERTYPE_DANSK
#define ETHERTYPE_DANSK         0x807B
#endif
#ifndef ETHERTYPE_MERIT
#define ETHERTYPE_MERIT         0x807C
#endif
#ifndef ETHERTYPE_VITALINK
#define ETHERTYPE_VITALINK      0x807D
#endif
#ifndef ETHERTYPE_VITALINK
#define ETHERTYPE_VITALINK      0x807E
#endif
#ifndef ETHERTYPE_VITALINK
#define ETHERTYPE_VITALINK      0x807F
#endif
#ifndef ETHERTYPE_VITALINK
#define ETHERTYPE_VITALINK      0x8080
#endif
#ifndef ETHERTYPE_COUNTERPOINT
#define ETHERTYPE_COUNTERPOINT  0x8081
#endif
#ifndef ETHERTYPE_COUNTERPOINT
#define ETHERTYPE_COUNTERPOINT  0x8082
#endif
#ifndef ETHERTYPE_COUNTERPOINT
#define ETHERTYPE_COUNTERPOINT  0x8083
#endif
#ifndef ETHERTYPE_ETHERTALK
#define ETHERTYPE_ETHERTALK     0x809B
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x809C
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x809D
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x809E
#endif
#ifndef ETHERTYPE_SPIDER
#define ETHERTYPE_SPIDER        0x809F
#endif
#ifndef ETHERTYPE_NIXDORF
#define ETHERTYPE_NIXDORF       0x80A3
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80A4
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80A5
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80A6
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80A7
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80A8
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80A9
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80AA
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80AB
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80AC
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80AD
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80AE
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80AF
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80B0
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80B1
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80B2
#endif
#ifndef ETHERTYPE_SIEMENS
#define ETHERTYPE_SIEMENS       0x80B3
#endif
#ifndef ETHERTYPE_DCA
#define ETHERTYPE_DCA           0x80C0
#endif
#ifndef ETHERTYPE_DCA
#define ETHERTYPE_DCA           0x80C1
#endif
#ifndef ETHERTYPE_DCA
#define ETHERTYPE_DCA           0x80C2
#endif
#ifndef ETHERTYPE_DCA
#define ETHERTYPE_DCA           0x80C3
#endif
#ifndef ETHERTYPE_PACER
#define ETHERTYPE_PACER         0x80C6
#endif
#ifndef ETHERTYPE_APPLITEK
#define ETHERTYPE_APPLITEK      0x80C7
#endif
#ifndef ETHERTYPE_INTERGRAPH
#define ETHERTYPE_INTERGRAPH    0x80C8
#endif
#ifndef ETHERTYPE_INTERGRAPH
#define ETHERTYPE_INTERGRAPH    0x80C9
#endif
#ifndef ETHERTYPE_INTERGRAPH
#define ETHERTYPE_INTERGRAPH    0x80CA
#endif
#ifndef ETHERTYPE_INTERGRAPH
#define ETHERTYPE_INTERGRAPH    0x80CB
#endif
#ifndef ETHERTYPE_INTERGRAPH
#define ETHERTYPE_INTERGRAPH    0x80CC
#endif
#ifndef ETHERTYPE_HARRIS
#define ETHERTYPE_HARRIS        0x80CD
#endif
#ifndef ETHERTYPE_HARRIS
#define ETHERTYPE_HARRIS        0x80CE
#endif
#ifndef ETHERTYPE_TAYLOR
#define ETHERTYPE_TAYLOR        0x80CF
#endif
#ifndef ETHERTYPE_TAYLOR
#define ETHERTYPE_TAYLOR        0x80D0
#endif
#ifndef ETHERTYPE_TAYLOR
#define ETHERTYPE_TAYLOR        0x80D1
#endif
#ifndef ETHERTYPE_TAYLOR
#define ETHERTYPE_TAYLOR        0x80D2
#endif
#ifndef ETHERTYPE_ROSEMOUNT
#define ETHERTYPE_ROSEMOUNT     0x80D3
#endif
#ifndef ETHERTYPE_ROSEMOUNT
#define ETHERTYPE_ROSEMOUNT     0x80D4
#endif
#ifndef ETHERTYPE_SNA
#define ETHERTYPE_SNA           0x80D5
#endif
#ifndef ETHERTYPE_VARIAN
#define ETHERTYPE_VARIAN        0x80DD
#endif
#ifndef ETHERTYPE_TRFS
#define ETHERTYPE_TRFS          0x80DE
#endif
#ifndef ETHERTYPE_INTEGRATED
#define ETHERTYPE_INTEGRATED    0x80DF
#endif
#ifndef ETHERTYPE_ALLENBRADLEY
#define ETHERTYPE_ALLENBRADLEY  0x80E0
#endif
#ifndef ETHERTYPE_ALLENBRADLEY
#define ETHERTYPE_ALLENBRADLEY  0x80E1
#endif
#ifndef ETHERTYPE_ALLENBRADLEY
#define ETHERTYPE_ALLENBRADLEY  0x80E2
#endif
#ifndef ETHERTYPE_ALLENBRADLEY
#define ETHERTYPE_ALLENBRADLEY  0x80E3
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80E4
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80E5
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80E6
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80E7
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80E8
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80E9
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80EA
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80EB
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80EC
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80ED
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80EE
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80EF
#endif
#ifndef ETHERTYPE_DATABILITY
#define ETHERTYPE_DATABILITY    0x80F0
#endif
#ifndef ETHERTYPE_RETIX
#define ETHERTYPE_RETIX         0x80F2
#endif
#ifndef ETHERTYPE_KINETICS
#define ETHERTYPE_KINETICS      0x80F4
#endif
#ifndef ETHERTYPE_KINETICS
#define ETHERTYPE_KINETICS      0x80F5
#endif
#ifndef ETHERTYPE_APOLLO
#define ETHERTYPE_APOLLO        0x80F7
#endif
#ifndef ETHERTYPE_WELLFLEET
#define ETHERTYPE_WELLFLEET     0x80FF
#endif
#ifndef ETHERTYPE_WELLFLEET
#define ETHERTYPE_WELLFLEET     0x8100
#endif
#ifndef ETHERTYPE_WELLFLEET
#define ETHERTYPE_WELLFLEET     0x8101
#endif
#ifndef ETHERTYPE_WELLFLEET
#define ETHERTYPE_WELLFLEET     0x8102
#endif
#ifndef ETHERTYPE_WELLFLEET
#define ETHERTYPE_WELLFLEET     0x8103
#endif
#ifndef ETHERTYPE_SYMBOLICS
#define ETHERTYPE_SYMBOLICS     0x8107
#endif
#ifndef ETHERTYPE_SYMBOLICS
#define ETHERTYPE_SYMBOLICS     0x8108
#endif
#ifndef ETHERTYPE_SYMBOLICS
#define ETHERTYPE_SYMBOLICS     0x8109
#endif
#ifndef ETHERTYPE_WATERLOO
#define ETHERTYPE_WATERLOO      0x8130
#endif
#ifndef ETHERTYPE_VGLABS
#define ETHERTYPE_VGLABS        0x8131
#endif
#ifndef ETHERTYPE_NOVELL
#define ETHERTYPE_NOVELL        0x8137
#endif
#ifndef ETHERTYPE_NOVELL
#define ETHERTYPE_NOVELL        0x8138
#endif
#ifndef ETHERTYPE_KTI
#define ETHERTYPE_KTI           0x8139
#endif
#ifndef ETHERTYPE_KTI
#define ETHERTYPE_KTI           0x813A
#endif
#ifndef ETHERTYPE_KTI
#define ETHERTYPE_KTI           0x813B
#endif
#ifndef ETHERTYPE_KTI
#define ETHERTYPE_KTI           0x813C
#endif
#ifndef ETHERTYPE_KTI
#define ETHERTYPE_KTI           0x813D
#endif
#ifndef ETHERTYPE_SNMP
#define ETHERTYPE_SNMP          0x814C
#endif
#ifndef ETHERTYPE_LOOPBACK
#define ETHERTYPE_LOOPBACK      0x9000
#endif
#ifndef ETHERTYPE_BRIDGE
#define ETHERTYPE_BRIDGE        0x9001
#endif
#ifndef ETHERTYPE_BRIDGE
#define ETHERTYPE_BRIDGE        0x9002
#endif
#ifndef ETHERTYPE_BRIDGE
#define ETHERTYPE_BRIDGE        0x9003
#endif
#ifndef ETHERTYPE_VITAL
#define ETHERTYPE_VITAL         0xFF00
#endif
